<CsoundSynthesizer>
<CsLicense>
Copyright (C) 2013 by Michael Gogins. 
All rights reserved. 
</CsLicense>
<CsOptions>
-odac1 -m3 -d
</CsOptions>
<CsInstruments>
sr = 48000
ksmps = 100
nchnls = 2
0dbfs = 400000

gkMasterLevel init 1.0
gkDistortFactor init 0.4
gkfirstharmonic init 0.4
gkReverbscFeedback init 0.9

gareverb1 init 0
gareverb2 init 0

alwayson "Controls"
alwayson "VariablesForControls"
alwayson "Reverb"

gisine ftgen 0, 0, 65536, 10, 1
gioctfn ftgen 0, 0, 65536, -19, 1, 0.5, 270, 0.5
giharmonics ftgen 0, 0, 65536, 10, 3, 0, 1, 1, 0, 2, 0, 2
giwaveshaping ftgen 0, 0, 65536, 13, 1, 1, 0, 1, 0, 2, 2, 1

instr Chebyshev
iattack init 40.0
idecay init 40.0
isustain init p3 - iattack
p3 = p3 + idecay
print p1, p2, p3, p4, p5, p6
ifundamental = p4 
inumerator = p5
idenominator = p6
ivelocity = p7
ipan = p8
iratio = inumerator / idenominator
ihertz = ifundamental * iratio
iamp = ampdb(ivelocity)
kenvelope transeg 0.0, iattack / 2.0, 2.5, iamp / 2.0, iattack / 2.0, -2.5, iamp, isustain, 0.0, iamp, idecay / 2.0, 2.5, iamp / 2.0, idecay / 2.0, -2.5, 0.0
asignal gbuzz kenvelope, ihertz, 15, gkfirstharmonic, gkDistortFactor, gisine
;asignal vco2 kenvelope, ihertz, 12
;asignal poscil3 kenvelope, ihertz, giharmonics
;asignal distort asignal, gkDistortFactor * .4, giwaveshaping
aleft, aright pan2 asignal, ipan
gareverb1 = gareverb1 + aleft
gareverb2 = gareverb1 + aright
endin

instr Hboscil
iattack init 40.0
idecay init 40.0
isustain init p3 - iattack
p3 = p3 + idecay
print p1, p2, p3, p4, p5, p6
ifundamental = p4 
inumerator = p5
idenominator = p6
ivelocity = p7
ipan = p8
iratio = inumerator / idenominator
ihertz = ifundamental * iratio
iamp = ampdb(ivelocity)
kenvelope transeg 0.0, iattack / 2.0, 2.5, iamp / 2.0, iattack / 2.0, -2.5, iamp, isustain, 0.0, iamp, idecay / 2.0, 2.5, iamp / 2.0, idecay / 2.0, -2.5, 0.0
icps = ihertz
kamp expseg	0.001,0.02,0.2,p3-0.01,0.001
kamp+=kenvelope
ktonemoddep	jspline	0.01,0.05,0.2
ktonemodrte	jspline	6,0.1,0.2
ktone oscil ktonemoddep, ktonemodrte, gisine
kbrite rspline -2,3,0.0002,3
ibasfreq	init icps
ioctcnt init 4
iphs init 0
a1 hsboscil kamp, ktone, kbrite, ibasfreq, gisine, gioctfn, ioctcnt, iphs	
amod poscil3 1, ibasfreq*3.47, gisine
arm = a1*amod
kmix expseg 0.001, 0.01, rnd(1), rnd(3)+0.3, 0.001
a1 ntrpol a1, arm, kmix
;a1 pareq a1/10, 400, 15, .707
;a1 tone a1, 500
kpanrte jspline 5, 0.05, 0.1
kpandep jspline 0.9, 0.2, 0.4
kpan poscil3 kpandep, kpanrte, gisine
a1,a2 pan2 a1, kpan
a1 delay a1, rnd(0.1)
a2 delay a2, rnd(0.1)
kenv linsegr 1, 1, 0
a1 = a1*kenv*20
a2 = a2*kenv*20

gasendL = gasendL+a1/5
gasendR = gasendR+a2/5
gareverb1 = gareverb1 + a1
gareverb2 = gareverb1 + a2
endin

instr Controls
gkslider1 invalue "slider1"
gkslider2 invalue "slider2"
gkslider3 invalue "slider3"
gkslider4 invalue "slider4"
gkslider5 invalue "slider5"
gkbutt1 invalue "butt1"
gkbutt2 invalue "butt2"
gkbutt3 invalue "butt3"
gkbutt4 invalue "butt4"
gkbutt5 invalue "butt5"
gktrackpadx invalue "trackpad.x"
gktrackpady invalue "trackpad.y"
gkaccelerometerx invalue "accelerometerX"
gkaccelerometery invalue "accelerometerY"
gkaccelerometerz invalue "accelerometerZ"
endin

instr VariablesForControls
gkfirstharmonic = (gkslider1 * 10) - 10
gkDistortFactor = gkslider2
if gkslider3 > 0 then
 gkpitchmod = gkslider3
endif
if gkslider4 > 0 then
 gkReverbscFeedback = gkslider4
endif
if gkslider5 > 0 then
 gkMasterLevel = gkslider5 * 5
endif
k5 = gkbutt1
k5a trigger k5, .5, 0
if k5a > 0 then
 event "i", 1, 0, 5, 4, 3, 60, 60
endif
endin

instr Reverbsc
aleft, aright reverbsc gareverb1, gareverb2,
 gkReverbscFeedback, 15000.0
aleft = gkMasterLevel * (gareverb1 + aleft * 0.8)
aright = gkMasterLevel * (gareverb2 + aright * 0.8)
outs aleft, aright
gareverb1 = 0
gareverb2 = 0
endin

instr Reverb
; p4 = gain of reverb. Adjust empirically
; for desired reverb time. .6 gives
; a good small "live" room sound, .8
; a small hall, .9 a large hall,
; .99 an enormous stone cavern.
 
; p5 = amount of random pitch modulation
; for the delay lines. 1 is the "normal"
; amount, but this may be too high for
; held pitches such as piano tones.
; Adjust to taste.
 
; p6 = cutoff frequency of lowpass filters
; in feedback loops of delay lines,
; in Hz. Lower cutoff frequencies results
; in a sound with more high-frequency
; damping.
 
; 8 delay line FDN reverb, with feedback matrix based upon 
; physical modeling scattering junction of 8 lossless waveguides
; of equal characteristic impedance. Based on Julius O. Smith III, 
; "A New Approach to Digital Reverberation using Closed Waveguide
; Networks," Proceedings of the International Computer Music 
; Conference 1985, p. 47-53 (also available as a seperate
; publication from CCRMA), as well as some more recent papers by
; Smith and others.
; Coded by Sean Costello, October 1999
itone = 16000 
ain1 = 	gareverb1
ain2 = 	gareverb2
asignal = (ain1 + ain2) * 0.5
afilt1 init 0
afilt2 init 0
afilt3 init 0
afilt4 init 0
afilt5 init 0
afilt6 init 0
afilt7 init 0
afilt8 init 0
idel1 = (2473.000/sr)
idel2 = (2767.000/sr)
idel3 = (3217.000/sr)
idel4 = (3557.000/sr)
idel5 = (3907.000/sr)
idel6 = (4127.000/sr)
idel7 = (2143.000/sr)
idel8 = (1933.000/sr)
; k1-k8 are used to add random pitch modulation to the
; delay lines. Helps eliminate metallic overtones
; in the reverb sound.
k1 randi .001, 3.1, .06
k2 randi .0011, 3.5, .9
k3 randi .0017, 1.11, .7
k4 randi .0006, 3.973, .3
k5 randi .001, 2.341, .63
k6 randi .0011, 1.897, .7
k7 randi .0017, 0.891, .9
k8 randi .0006, 3.221, .44
; apj is used to calculate "resultant junction pressure" for 
; the scattering junction of 8 lossless waveguides
.; of equal characteristic impedance. If you wish to
; add more delay lines, simply add them to the following 
; equation, and replace the .25 by 2/N, where N is the 
; number of delay lines.
apj = .25 * (afilt1 + afilt2 + afilt3 + afilt4 + afilt5 + afilt6 + afilt7 + afilt8)
adum1 delayr 1
adel1 deltapi idel1 + k1 * gkpitchmod
 delayw asignal + apj - afilt1
adum2 delayr 1
adel2 deltapi idel2 + k2 * gkpitchmod
 delayw asignal + apj - afilt2
adum3 delayr 1
adel3 deltapi idel3 + k3 * gkpitchmod
 delayw asignal + apj - afilt3
adum4 delayr 1
adel4 deltapi idel4 + k4 * gkpitchmod
 delayw asignal + apj - afilt4
adum5 delayr 1
adel5 deltapi idel5 + k5 * gkpitchmod
 delayw asignal + apj - afilt5
adum6 delayr 1
adel6 deltapi idel6 + k6 * gkpitchmod
 delayw asignal + apj - afilt6
adum7 delayr 1
adel7 deltapi idel7 + k7 * gkpitchmod
 delayw asignal + apj - afilt7
adum8 delayr 1
adel8 deltapi idel8 + k8 * gkpitchmod
 delayw asignal + apj - afilt8
; 1st order lowpass filters in feedback
; loops of delay lines.
afilt1 tone adel1 * gkReverbscFeedback, itone
afilt2 tone adel2 * gkReverbscFeedback, itone
afilt3 tone adel3 * gkReverbscFeedback, itone
afilt4 tone adel4 * gkReverbscFeedback, itone
afilt5 tone adel5 * gkReverbscFeedback, itone
afilt6 tone adel6 * gkReverbscFeedback, itone
afilt7 tone adel7 * gkReverbscFeedback, itone
afilt8 tone adel8 * gkReverbscFeedback, itone
; The outputs of the delay lines are summed
; and sent to the stereo outputs. This could
; easily be modified for a 4 or 8-channel 
; sound system.
aout1 = (afilt1 + afilt3 + afilt5 + afilt7)
aout2 = (afilt2 + afilt4 + afilt6 + afilt8)
; To the master output.
aleft = gkMasterLevel * (gareverb1 + aout1 * 0.8)
aright = gkMasterLevel * (gareverb2 + aout2 * 0.8)
outs aleft, aright
gareverb1 = 0
gareverb2 = 0
endin

</CsInstruments>
<CsScore>

; Change the tempo, if you like.
t 60

; p1 p2 p3 p4 p5 p6 p7 p8
; insno onset duration fundamental numerator denominator velocity pan

; What I want here is just intonation C major 7, G major 7, G 7, C major with voice leading.

i 1 0 60 60 1 1 60 -0.875
i 1 0 180 60 3 2 60 0.000
i 1 0 60 60 28 15 60 0.875

i 1 60 60 60 9 8 60 0.875
i 1 60 30 60 10 7 64 -0.875
i 1 90 30 60 4 3 68 0.875

i 1 120 60 60 1 1 64 -0.875
i 1 120 60 60 5 4 62 0.000
i 1 120 60 60 2 1 58 0.875
s 10.0
e 10.0
</CsScore>
</CsoundSynthesizer>
 
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>0</x>
 <y>0</y>
 <width>525</width>
 <height>549</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>0</r>
  <g>85</g>
  <b>0</b>
 </bgcolor>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>slider1</objectName>
  <x>20</x>
  <y>47</y>
  <width>502</width>
  <height>25</height>
  <uuid>{5e269dfb-9532-41d3-83d8-d42cfde539f7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.77091633</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>21</x>
  <y>22</y>
  <width>504</width>
  <height>25</height>
  <uuid>{e87c67e0-c4b2-407f-bb2f-242be34a52ec}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>slider1</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>16</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>slider2</objectName>
  <x>20</x>
  <y>94</y>
  <width>502</width>
  <height>25</height>
  <uuid>{91144bb6-31e1-44e5-9d98-53b6c9c93532}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.66334661</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>21</x>
  <y>69</y>
  <width>504</width>
  <height>26</height>
  <uuid>{236a0eb0-fd30-47c2-8845-25315155f74b}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>slider2</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>16</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>slider3</objectName>
  <x>20</x>
  <y>141</y>
  <width>502</width>
  <height>25</height>
  <uuid>{ad3f9dd8-7147-4f62-9770-e09aa418e837}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.49402390</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>21</x>
  <y>116</y>
  <width>502</width>
  <height>28</height>
  <uuid>{8c8248ab-8c18-484d-b822-91f9f4956fdb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>slider3</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>16</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>slider4</objectName>
  <x>20</x>
  <y>188</y>
  <width>502</width>
  <height>25</height>
  <uuid>{93eb0db1-8e07-421f-8121-357e84ff85e4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.97211155</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>21</x>
  <y>163</y>
  <width>502</width>
  <height>28</height>
  <uuid>{2bdfdb11-1cc5-40fa-af6e-774ea1cab987}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>slider4</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>16</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBHSlider">
  <objectName>slider5</objectName>
  <x>20</x>
  <y>235</y>
  <width>502</width>
  <height>28</height>
  <uuid>{f7ecf097-1755-4681-8f8f-d4b1acfdc09a}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <minimum>0.00000000</minimum>
  <maximum>1.00000000</maximum>
  <value>0.90239044</value>
  <mode>lin</mode>
  <mouseControl act="jump">continuous</mouseControl>
  <resolution>-1.00000000</resolution>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>21</x>
  <y>210</y>
  <width>502</width>
  <height>28</height>
  <uuid>{13642f66-f23b-4727-86a3-74ba1ffb5cf1}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>slider5</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>16</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>butt5</objectName>
  <x>422</x>
  <y>273</y>
  <width>100</width>
  <height>30</height>
  <uuid>{94adda4c-f3e4-4bdc-8d82-eff3a6c64422}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>butt5</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>butt3</objectName>
  <x>220</x>
  <y>273</y>
  <width>100</width>
  <height>30</height>
  <uuid>{a8e83217-4340-4868-9762-60ac5272411c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>butt3</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>butt1</objectName>
  <x>20</x>
  <y>273</y>
  <width>100</width>
  <height>30</height>
  <uuid>{558ef416-b71a-40cd-a160-02f70770ca0e}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>butt1</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>true</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>butt2</objectName>
  <x>120</x>
  <y>273</y>
  <width>100</width>
  <height>30</height>
  <uuid>{dfa120a7-83a3-498c-997e-20c936989eb1}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>butt2</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>true</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>butt4</objectName>
  <x>321</x>
  <y>273</y>
  <width>100</width>
  <height>30</height>
  <uuid>{3225236c-43f3-4276-a227-920e79b83baf}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>butt4</text>
  <image>/</image>
  <eventLine>i1 0 10</eventLine>
  <latch>false</latch>
  <latched>true</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>trackpad.x</objectName>
  <x>21</x>
  <y>349</y>
  <width>503</width>
  <height>231</height>
  <uuid>{7bdad897-657c-4a54-9206-709cc8534ebb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>trackpad.y</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.58648111</xValue>
  <yValue>0.54112554</yValue>
  <type>crosshair</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>234</g>
   <b>0</b>
  </color>
  <randomizable group="0" mode="both">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>slider1</objectName>
  <x>443</x>
  <y>23</y>
  <width>80</width>
  <height>25</height>
  <uuid>{7ef693ee-baeb-4c01-bbea-44d8b884b57f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.771</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>slider1</objectName>
  <x>443</x>
  <y>211</y>
  <width>80</width>
  <height>25</height>
  <uuid>{1ebffaf7-0a51-4395-af00-21494aad303c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.771</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>slider4</objectName>
  <x>443</x>
  <y>166</y>
  <width>80</width>
  <height>25</height>
  <uuid>{4a8f2804-f935-48ce-a461-6e0d42a1a9e3}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.972</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>slider3</objectName>
  <x>443</x>
  <y>118</y>
  <width>80</width>
  <height>25</height>
  <uuid>{d26c20e9-dfb7-4d91-bea8-456064879ffb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.494</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>slider2</objectName>
  <x>443</x>
  <y>70</y>
  <width>80</width>
  <height>25</height>
  <uuid>{c5bc6516-4212-4bfc-a3ab-9267190771ff}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.663</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>trackpad.x</objectName>
  <x>444</x>
  <y>316</y>
  <width>80</width>
  <height>25</height>
  <uuid>{875228fc-e82f-43c2-83bb-5cc963facc98}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.586</label>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>trackpad.y</objectName>
  <x>531</x>
  <y>350</y>
  <width>80</width>
  <height>25</height>
  <uuid>{ae997c24-fc31-43b0-89aa-db0a8ffde4b7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.541</label>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>15</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>255</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
