<CsoundSynthesizer>
<CsLicense>
D R O N E
Copyright (C) 2013 by Michael Gogins. 
All rights reserved. 
</CsLicense>
<CsOptions>
-odac -m3 -d --sample-accurate -j4
</CsOptions>
<CsInstruments>

sr                      =           48000
ksmps                   =           480
nchnls                  =           2
0dbfs                   =           100000

gkDistortFactor         init        1.0
gkReverbscFeedback      init        0.9
gkMasterLevel           init        1.0

gareverb1               init        0
gareverb2               init        0

                        alwayson    "Triggers"         
                        alwayson    "Reverb"

gisine		            ftgen		0, 0, 65536,  10, 1
gioctfn		            ftgen		0, 0, 65536, -19, 1, 0.5, 270, 0.5
;                       A few harmonics...
gif1                    ftgen       0, 0, 65536,  10, 3, 0, 1, 0, 0, 2, 0, 2
;                       ...distorted by waveshaping.
gif2                    ftgen       0, 0, 65536,  13, 1, 1, 0, 1, 0, 2, 2, 1

                        instr       Chebyshev
iattack                 init        40.0
idecay                  init        40.0
isustain        	    init        p3 - iattack
p3          		    =           p3 + idecay
                        print       p1, p2, p3, p4, p5, p6
ifundamental            =           p4  
inumerator              =           p5
idenominator            =           p6
ivelocity               =           p7
ipan                    =           p8
iratio                  =           inumerator / idenominator
ihertz                  =           ifundamental * iratio
iamp                    =           ampdb(ivelocity)
kenvelope               transeg     0.0, iattack / 2.0, 2.5, iamp / 2.0, iattack / 2.0, -2.5, iamp, isustain, 0.0, iamp, idecay / 2.0, 2.5, iamp / 2.0, idecay / 2.0, -2.5, 0.0
asignal                 poscil3     kenvelope, ihertz, gif1
gkDistortFactor         chnget      "slider1"
asignal                 distort     asignal, gkDistortFactor * .4, gif2
aleft, aright           pan2        asignal , ipan
gareverb1               =           gareverb1 + aleft
gareverb2               =           gareverb1 + aright
                        endin
            
                        instr		Hboscil
                        print       p1, p2, p3, p4, p5, p6
iattack                 init        40.0
idecay                  init        40.0
isustain        	    init        p3 - iattack
p3          		    =           p3 + idecay
                        print       p1, p2, p3, p4, p5, p6, p7, p8
ifundamental            =           p4  
inumerator              =           p5
idenominator            =           p6
ivelocity               =           p7
ipan                    =           p8
iratio                  =           inumerator / idenominator
ihertz                  =           ifundamental * iratio
icps                    =           ihertz
iamp                    =           ampdb(ivelocity)
kenvelope               transeg     0.0, iattack / 2.0, 2.5, iamp / 2.0, iattack / 2.0, -2.5, iamp, isustain, 0.0, iamp, idecay / 2.0, 2.5, iamp / 2.0, idecay / 2.0, -2.5, 0.0

gktrans                 chnget      "slider4"
kamp		  expseg		0.001,0.02,0.2,p3-0.01,0.001
ktonemoddep	            jspline		0.01,0.05,0.2
ktonemodrte	            jspline		6,0.1,0.2
ktone		            oscil		ktonemoddep,ktonemodrte,gisine
kbrite		            rspline		-2,3,0.0002,3
ibasfreq	            init		icps
ioctcnt		            init		2
iphs		            init		0
a1 		                hsboscil 	kamp, ktone, kbrite, ibasfreq, gisine, gioctfn, ioctcnt, iphs	
amod		            oscili		1, ibasfreq*3.47, gisine
arm		                =		    a1*amod
kmix		            expseg		0.001, 0.01, rnd(1), rnd(3)+0.3, 0.001
a1		                ntrpol		a1, arm, kmix
a1 		                pareq 		a1/10, 400, 15, .707
a1		                tone		a1, 500
kpanrte		            jspline		5, 0.05, 0.1
kpandep		            jspline		0.9, 0.2, 0.4
kpan		            oscili		kpandep, kpanrte, gisine
a1,a2		            pan2		a1, kpan
a1		                delay		a1, rnd(0.1)
a2		                delay		a2, rnd(0.1)
kenv		            linsegr		1, 1, 0
a1		                =		    a1*kenv
a2		                =		    a2*kenv
gareverb1               =           gareverb1 + a1 * 10000
gareverb2               =           gareverb1 + a2 * 10000
                        endin

                        instr       Triggers
k5                      chnget      "butt1"
k5a                     trigger     k5, .5, 0
                        if          k5a > 0 then
                                    event "i", 2, 0, 5, 60, 4, 3, 60, 0
                        endif
                        endin
            
                        instr       Reverbsc
gkReverbscFeedback      chnget      "slider2"
aleft, aright           reverbsc    gareverb1, gareverb2, gkReverbscFeedback, 15000.0
gkMasterLevel           chnget      "slider3"
gkwet                   chnget      "slider4"
gkdry                   =           1 - gkwet
; To the master output.
aleft                   =           gkMasterLevel * 10 * ((gkdry * gareverb1) + (gkwet * aleft))
aright                  =           gkMasterLevel * 10 * ((gkdry * gareverb2) + (gkwet * aright))
                        outs        aleft, aright
gareverb1               =           0
gareverb2               =           0
                        endin

                        instr       Reverb
; p4 = gain of reverb. Adjust empirically
; for desired reverb time. .6 gives
; a good small "live" room sound, .8
; a small hall, .9 a large hall,
; .99 an enormous stone cavern.
  
; p5 = amount of random pitch modulation
; for the delay lines. 1 is the "normal"
; amount, but this may be too high for
; held pitches such as piano tones.
; Adjust to taste.
  
; p6 = cutoff frequency of lowpass filters
; in feedback loops of delay lines,
; in Hz. Lower cutoff frequencies results
; in a sound with more high-frequency
; damping.
  
; 8 delay line FDN reverb, with feedback matrix based upon 
; physical modeling scattering junction of 8 lossless waveguides
; of equal characteristic impedance. Based on Julius O. Smith III, 
; "A New Approach to Digital Reverberation using Closed Waveguide
; Networks," Proceedings of the International Computer Music 
; Conference 1985, p. 47-53 (also available as a seperate
; publication from CCRMA), as well as some more recent papers by
; Smith and others.
; Coded by Sean Costello, October 1999
kpitchmod               chnget      "slider2"
gkMasterLevel           chnget      "slider3"
gkwet                   chnget      "slider4"
gkdry                   =           1 - gkwet
itone 			        = 			16000     		
ain1 			        =			gareverb1
ain2 			        =			gareverb2
asignal 		        = 			(ain1 + ain2) * 0.5
afilt1 			        init 			0
afilt2 			        init 			0
afilt3 			        init 			0
afilt4 			        init 			0
afilt5 			        init 			0
afilt6 			        init 			0
afilt7 			        init 			0
afilt8 			        init 			0
idel1 			        = 			(2473.000/sr)
idel2 			        = 			(2767.000/sr)
idel3 			        = 			(3217.000/sr)
idel4 			        = 			(3557.000/sr)
idel5 			        = 			(3907.000/sr)
idel6 			        = 			(4127.000/sr)
idel7 			        = 			(2143.000/sr)
idel8 			        = 			(1933.000/sr)
; k1-k8 are used to add random pitch modulation to the
; delay lines. Helps eliminate metallic overtones
; in the reverb sound.
k1      		        randi   		.001, 3.1, .06
k2      		        randi   		.0011, 3.5, .9
k3      		        randi   		.0017, 1.11, .7
k4      		        randi   		.0006, 3.973, .3
k5      		        randi   		.001, 2.341, .63
k6      		        randi   		.0011, 1.897, .7
k7      		        randi   		.0017, 0.891, .9
k8      		        randi   		.0006, 3.221, .44
; apj is used to calculate "resultant junction pressure" for 
; the scattering junction of 8 lossless waveguides
; of equal characteristic impedance. If you wish to
; add more delay lines, simply add them to the following 
; equation, and replace the .25 by 2/N, where N is the 
; number of delay lines.
apj 			        = 			.25 * (afilt1 + afilt2 + afilt3 + afilt4 + afilt5 + afilt6 + afilt7 + afilt8)
adum1   		        delayr  		1
adel1   		        deltapi 		idel1 + k1 * kpitchmod
                        delayw  		asignal + apj - afilt1
adum2   		        delayr  		1
adel2   		        deltapi 		idel2 + k2 * kpitchmod
                        delayw  		asignal + apj - afilt2
adum3   		        delayr  		1
adel3   		        deltapi 		idel3 + k3 * kpitchmod
                        delayw  		asignal + apj - afilt3
adum4   		        delayr  		1
adel4   		        deltapi 		idel4 + k4 * kpitchmod
                        delayw  		asignal + apj - afilt4
adum5   		        delayr  		1
adel5   		        deltapi 		idel5 + k5 * kpitchmod
                        delayw  		asignal + apj - afilt5
adum6   		        delayr  		1
adel6   		        deltapi 		idel6 + k6 * kpitchmod
                        delayw  		asignal + apj - afilt6
adum7   		        delayr  		1
adel7   		        deltapi 		idel7 + k7 * kpitchmod
                        delayw  		asignal + apj - afilt7
adum8   		        delayr  		1
adel8   		        deltapi 		idel8 + k8 * kpitchmod
                        delayw  		asignal + apj - afilt8
; 1st order lowpass filters in feedback
; loops of delay lines.
afilt1  		        tone    		adel1 * gkReverbscFeedback, itone
afilt2  		        tone    		adel2 * gkReverbscFeedback, itone
afilt3  		        tone    		adel3 * gkReverbscFeedback, itone
afilt4  		        tone    		adel4 * gkReverbscFeedback, itone
afilt5  		        tone    		adel5 * gkReverbscFeedback, itone
afilt6  		        tone    		adel6 * gkReverbscFeedback, itone
afilt7  		        tone    		adel7 * gkReverbscFeedback, itone
afilt8  		        tone    		adel8 * gkReverbscFeedback, itone
; The outputs of the delay lines are summed
; and sent to the stereo outputs. This could
; easily be modified for a 4 or 8-channel 
; sound system.
aout1 			        = 			(afilt1 + afilt3 + afilt5 + afilt7)
aout2 			        = 			(afilt2 + afilt4 + afilt6 + afilt8)
; To the master output.
aleft                   =           gkMasterLevel * 10 * ((gkdry * ain1) + (gkwet * aout1))
aright                  =           gkMasterLevel * 10 * ((gkdry * ain2) + (gkwet * aout2))
                        outs        aleft, aright
gareverb1               =           0
gareverb2               =           0
                        endin

</CsInstruments>
<CsScore>
f 0 3600
t   0      30

;   p1      p2      p3          p4              p5         p6           p7        p8
;   insno   onset   duration    fundamental     numerator  denominator  velocity  pan

; What I want here is just intonation C major 7, G major 7, G 7, C major with voice leading.

i   1       0       60          60              1          1            60       -0.875
i   1       0      180          60              3          2            60        0.000
i   1       0       60          60             28         15            60        0.875

i   1       60      60          60              9          8            60        0.875
i   1       60      30          60              10         7            64       -0.875
i   1       90      30          60              4          3            68        0.875

i   1       120     60          60          	1          1            64       -0.875
i   1       120     60          60          	5          4            62        0.000
i   1       120     60          60         	    2          1            58        0.875

s   10.0
e   10.0
</CsScore>
</CsoundSynthesizer>
 
